﻿
Enumeration
  #Window
  
  #GadgetKartinka
  #SamaKartinka
  
  #File
EndEnumeration

; массив с кодами цветов
Global Dim SegaSegmentColor.a(16)
; 0, 36, 72, 109, 145, 181, 219, 255
SegaSegmentColor(2)  =  36
SegaSegmentColor(4)  =  72
SegaSegmentColor(6)  = 109
SegaSegmentColor(8)  = 145
SegaSegmentColor(10) = 181
SegaSegmentColor(12) = 219
SegaSegmentColor(14) = 255

; создаем сложный массив с 4 колонками и 16 строчек в каждой. как Ексель таблица.
Structure colorstructure
  ; 17 а не 16 - потому что считается количество ячеек с 0. но мне для удобства хотелось бы с 1 считать.
  ; поэтому 17
  ColorNum.l[17] 
EndStructure
Global Dim PalNum.colorstructure(4)

; читаем файл с палитрами.
If ReadFile(#File, "pal.bin")
  
  ; первая палитра
  pal = 1
  For colornumindex = 1 To 16
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; вторая палитра
  pal = 2
  For colornumindex = 1 To 16
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; третья палитра
  pal = 3
  For colornumindex = 1 To 16
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; четвертая палитра
  pal = 4
  For colornumindex = 1 To 16
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  CloseFile(#File)
EndIf

; создаем само изображение, пока пустое. это будет черный длинный прямоугольник
CreateImage(#SamaKartinka, 320, 80)

; стартуем сам процесс рисования
; ставим вывод, что рисовать в картинку
If StartDrawing(ImageOutput(#SamaKartinka))
    
  ; сначала черный фон на всю картинку
  Box(0, 0, 320, 80, RGB(0, 0, 0)) ; это черный цвет. в принципе можно было просто 0 написать вместо RGB(0, 0, 0)
  
  y = 0 ; первая палитра начнет рисоваться с самого верха 
  ; стартанем цикл в цикле с перебором всех ячеек в нашем массиве палитр
  For Pal = 1 To 4
    ; гоняем все 4 палитры
    
    ; на входе в цвета сбрасываем координату Х на начало картинки
    x = 0
    For ColorNumIndex = 1 To 16
      ; гоняем все цвета в конкретной палитре
      
      Box(x, y, 20, 20, PalNum(Pal)\ColorNum[ColorNumIndex])
      
      ; сдвигаем координату вправо для следующего цвета
      x + 20 
    Next
    ; когда достигли последнего 16 цвета в палитре - сдвигаем координату на одну строчку ниже
    y + 20
  Next
  
  ; остановка рисования
  StopDrawing()
EndIf

If OpenWindow(#Window, 100, 100, 340, 100, "Якубович под грибами играет в Сегу", #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
  
  ; добавляем гаджет-картинку, с подготовленным изображением
  ImageGadget(#GadgetKartinka, 10, 10, 320, 80, ImageID(#SamaKartinka))
  
  Repeat
    Select WaitWindowEvent()

      Case #PB_Event_CloseWindow
        qiut = 1
   
    EndSelect
  Until qiut = 1

EndIf

End
; IDE Options = PureBasic 6.00 LTS (Windows - x86)
; CursorPosition = 135
; FirstLine = 116
; EnableXP
; DPIAware